From 7aa86ed1e8669bcd06970ba23a1ff5abd5da81e6 Mon Sep 17 00:00:00 2001
From: Sylvain Munaut <tnt@246tNt.com>
Date: Thu, 24 Sep 2009 01:44:24 +0200
Subject: [PATCH 3/5] [gsm_04_08] Fix gsm48_send_rr_ciph_mode algorithm ID

The algorithm ID used in the GSM 04.08 RR message is
(x-1) for A5/x. In RSL it's (x+1) for A5/x so there is
a difference of 2.

Signed-off-by: Sylvain Munaut <tnt@246tNt.com>
---
 openbsc/src/gsm_04_08.c |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

diff --git a/openbsc/src/gsm_04_08.c b/openbsc/src/gsm_04_08.c
index 1cf738e..826ae6a 100644
--- a/openbsc/src/gsm_04_08.c
+++ b/openbsc/src/gsm_04_08.c
@@ -1701,7 +1701,7 @@ int gsm48_send_rr_ciph_mode(struct gsm_lchan *lchan)
 	if (lchan->encr.alg_id <= RSL_ENC_ALG_A5(0))
 		ciph_mod_set = 0;
 	else
-		ciph_mod_set = (lchan->encr.alg_id-1)<<1 | 1;
+		ciph_mod_set = (lchan->encr.alg_id-2)<<1 | 1;
 
 	gh = (struct gsm48_hdr *) msgb_put(msg, sizeof(*gh) + 1);
 	gh->proto_discr = GSM48_PDISC_RR;
-- 
1.6.4

